/* drawx.c - A set of drawing utilities */

#include "image.h"
#include <X11/Xutil.h>

extern Display *theDisplay;   /* from initx.c */

/* drawline()
 *
 * Draws a line from (x1,y1) to (x2,y2) in the window theWindow, with
 * the graphics context theGC.
 */

drawLine(theWindow, theGC, x1, y1, x2, y2)

Window theWindow;
GC     theGC;
int    x1,y1;
int    x2,y2;

{
  XDrawLine(theDisplay,theWindow,theGC,x1,y1,x2,y2);
}


/* drawrectangle()
 *
 * Draws a rectangle in the given window/GC
 */

drawRectangle(theWindow, theGC, x, y, width, height)

Window theWindow;
GC     theGC;
int    x,y,width,height;

{
  XDrawRectangle(theDisplay, theWindow, theGC, x, y, width, height);
}


drawPoint(theWindow, theGC, x, y)

Window theWindow;
GC     theGC;
int    x,y;

{
  XDrawPoint(theDisplay, theWindow, theGC, x, y);
}


void plotPoints(theWindow, theGC, points,maxx,maxy,count)

Window theWindow;
GC theGC;
char points[300][300];
int maxx,maxy;
int *count;
{
  int x,y;
  *count = 0;

  for(y=0; y<maxy; y++)
    for(x=0; x<maxx; x++){
      if(points[x][y] == '1'){
	drawPoint(theWindow, theGC, x+25,y+25);
        (*count)++;
      }

    }
    XFlush(theDisplay);
    printf("Plotted %d points.",*count);
}


